package com.ngMAT.Samples.EZScott;

import  java.sql.Connection;
import  java.sql.ResultSet;
import  java.sql.Statement;
import  java.sql.SQLException;
import  java.util.Vector;
import  com.ngMAT.Common.ngmDBObject;
import  com.ngMAT.Common.LowLevelException;

public class EZEmp extends ngmDBObject
{
    public  short   empno = 0;
    public  String  ename = null;
    public  String  job = null;
    public  short   mgr = 0;
    public  java.sql.Date   hiredate = null;
    public  double  sal = 0;
    public  double  comm = 0;
    public  short   deptno = 0;

    public static Vector selectAll  (EZScottContext context, String options)
    {
        String sql = "select "
                + "empno,"
                + "ename,"
                + "job,"
                + "mgr,"
                + "hiredate,"
                + "sal,"
                + "comm,"
                + "deptno"
            + " from emp " + options;
        Connection con = context.getConnection();
        try {
            Statement stmt = con.createStatement();
            ResultSet rs = stmt.executeQuery (sql);
            Vector v = new Vector();
            while (rs.next())
            {
                v.addElement (fetch (rs));
            }
            return v;
        } catch (SQLException e) {
            throw new LowLevelException (e);
        }
    }

    //emp SELECT
    public static EZEmp select (EZScottContext context, short empno)
    {
        Connection con = context.getConnection();
        String sql = "select "
                + "empno,"
                + "ename,"
                + "job,"
                + "mgr,"
                + "hiredate,"
                + "sal,"
                + "comm,"
                + "deptno"
            + " from emp"
            + "\r\nwhere empno = " + empno;
        try {
            Statement stmt = con.createStatement();
            ResultSet rs = stmt.executeQuery (sql);
            EZEmp   res = null;
            if (rs.next()) {
                res = fetch(rs);
            }
            rs.close();
            stmt.close();
            return res;
        } catch (SQLException e) {
            throw new LowLevelException (e);
        }
    }

    public static EZEmp fetch (ResultSet rs)
    {
        EZEmp   d=new EZEmp();
        try {
            d.empno = rs.getShort("empno");
            d.ename = rs.getString("ename");
            d.job = rs.getString("job");
            d.mgr = rs.getShort("mgr");
            d.hiredate = rs.getDate("hiredate");
            d.sal = rs.getDouble("sal");
            d.comm = rs.getDouble("comm");
            d.deptno = rs.getShort("deptno");
        } catch (SQLException e) {
            throw new LowLevelException (e);
        }
        return d;
    }

    public Object clone ()
    {
        EZEmp   d = (EZEmp)super.clone();
        d.empno = empno;
        d.ename = ename;
        d.job = job;
        d.mgr = mgr;
        d.hiredate = new java.sql.Date (hiredate.getTime());
        d.sal = sal;
        d.comm = comm;
        d.deptno = deptno;
        return d;
    }

    public boolean equals (EZEmp d)
     {
        if (d.empno != empno) return false;
        if (! equals_n (ename, ename)) return false;
        if (! equals_n (job, job)) return false;
        if (d.mgr != mgr) return false;
        if (! equals_n (hiredate, hiredate)) return false;
        if (d.sal != sal) return false;
        if (d.comm != comm) return false;
        if (d.deptno != deptno) return false;
        return true;
    }
}
