package com.ngMAT.Samples.EZScott;

import  java.util.Vector;
import  com.ngMAT.HTML.HTMLTemplate;
import  com.ngMAT.HTML.ParsedTable;
import  com.ngMAT.servlet.EZServlet;
import  com.ngMAT.servlet.EZServletContext;

public class EZScott    extends EZServlet
{
    public  void    processApplication (EZServletContext _context)
    {
        EZScottContext context = (EZScottContext)_context;
        EZScottConfig config = (EZScottConfig)context.getConfig();
        String  order = context.getParameter ("order");
        if (order == null) order = config.default_order;
        String  option = "order by " + order;
        context.assignConnection();
        Vector  v = EZEmp.selectAll (context, option);
        HTMLTemplate    template = context.getTemplate (config.template_name);
        template.setTagValue ("now", config.df.format (new java.util.Date()));
        ParsedTable pt = template.getParsedTable ("emp_list");
        for (int i = 0; i < v.size(); i++)
        {
            HTMLTemplate row = pt.getRowTemplate();
            EZEmp emp = (EZEmp)v.elementAt (i);
            row.setInsertionTagValue ("EMPNO", emp.empno);
            row.setInsertionTagValue ("ENAME", emp.ename);
            row.setInsertionTagValue ("JOB", emp.job);
            row.setInsertionTagValue ("MGR", emp.mgr);
            row.setInsertionTagValue ("HIREDATE", config.df.format (emp.hiredate));
            row.setInsertionTagValue ("SAL", emp.sal);
            row.setInsertionTagValue ("COMM", emp.comm);
            row.setInsertionTagValue ("DEPTNO", emp.deptno);
            pt.addRow (row);
        }
        context.releaseConnection();
        context.setOutput (template);
    }
}
