package com.ngMAT.Samples.EZScott;

import  java.sql.Connection;
import  com.ngMAT.Common.DBConnection;
import  com.ngMAT.servlet.EZServletContext;
import  com.ngMAT.servlet.EZSApplicationProcessException;

public class EZScottContext extends EZServletContext
{
    private Connection  con = null;
    public  Connection  getConnection()
    {
        return con;
    }
    public  void    assignConnection ()
    {
        try {
            con = DBConnection.getConnection (((EZScottConfig)config).db_connection_name);
        } catch (Exception e) {
            getLog().printStackTrace (e);
            throw new EZSApplicationProcessException (e);
        }
    }

    public  void    releaseConnection()
    {
        DBConnection.releaseConnection (con);
        con = null;
    }
}
